--------------------------------------------------------------------------------
-- fixme: figure out why the score of the last possible window is not calculated
--------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;
use work.user_pkg.all;


entity pwm is
	port (
	 reset_n		: in std_logic;	 
	 user_clk	: in std_logic;
	 stall		: in std_logic;
	 valid		: in std_logic;

	 elem_in		: in std_logic_vector(7 downto 0);
	 index_in	: in std_logic_vector(25 downto 0);
	 pwm_table  : in lu_table;

	 data_out	: out std_logic_vector(37 downto 0);
	 index_out	: out std_logic_vector(25 downto 0);
	 data_out_valid	: out std_logic
	);
end pwm;

architecture rtl of pwm is
	signal elem_in_00, elem_in_01, elem_in_02, elem_in_03, elem_in_04, elem_in_05, elem_in_06, elem_in_07 : std_logic_vector(7 downto 0);
	signal data_00, data_01, data_02, data_03, data_04, data_05, data_06, data_07 : std_logic_vector(37 downto 0);
	signal add_00_01, add_02_03, add_04_05, add_06_07, add_00_03, add_04_07, add_00_07 : std_logic_vector(37 downto 0);
	signal index_s1, index_s2, index_s3, index_s4, index_s5 : std_logic_vector(25 downto 0);
	signal elem_string : elem_array;
begin

	do_stuff : process (reset_n, user_clk)
	begin
		if reset_n='0' then
			elem_in_00 <= (others => '1');
			elem_in_01 <= (others => '1');
			elem_in_02 <= (others => '1');
			elem_in_03 <= (others => '1');
			elem_in_04 <= (others => '1');
			elem_in_05 <= (others => '1');
			elem_in_06 <= (others => '1');
			elem_in_07 <= (others => '1');

			data_00 <= (others => '0');
			data_01 <= (others => '0');
			data_02 <= (others => '0');
			data_03 <= (others => '0');
			data_04 <= (others => '0');
			data_05 <= (others => '0');
			data_06 <= (others => '0');
			data_07 <= (others => '0');

			add_00_01 <= (others => '0');
			add_02_03 <= (others => '0');
			add_04_05 <= (others => '0');
			add_06_07 <= (others => '0');
			add_00_03 <= (others => '0');
			add_04_07 <= (others => '0');
			add_00_07 <= (others => '0');

			index_s1 <= (others => '1');
			index_s2 <= (others => '1');
			index_s3 <= (others => '1');
			index_s4 <= (others => '1');
			index_s5 <= (others => '1');

			data_out <= (others => '0');
			index_out <= (others => '1');
			data_out_valid <= '0';
		elsif user_clk='1' and user_clk'event then
			if stall='0' then
				if valid='1' then
					elem_in_00 <= elem_string(0);
					elem_in_01 <= elem_string(1);
					elem_in_02 <= elem_string(2);
					elem_in_03 <= elem_string(3);
					elem_in_04 <= elem_string(4);
					elem_in_05 <= elem_string(5);
					elem_in_06 <= elem_string(6);
					elem_in_07 <= elem_string(7);
					
					if (	elem_string(0)(7) or elem_string(1)(7) or elem_string(2)(7) or elem_string(3)(7) or
							elem_string(4)(7) or elem_string(5)(7) or elem_string(6)(7) or elem_string(7)(7))='0' then 
--						report "pwm input valid with valid index"; 
						index_s1 <= index_in-8;
					else
--						report "pwm input valid with INVALID index"; 
						index_s1 <= (others => '1');
					end if;
				
					for i in 0 to 6 loop
						elem_string(i) <= elem_string(i+1);
					end loop;
					elem_string(7) <= elem_in;
				else
--					report "pwm input NOT valid";
					elem_in_00 <= (others => '1');
					elem_in_01 <= (others => '1');
					elem_in_02 <= (others => '1');
					elem_in_03 <= (others => '1');
					elem_in_04 <= (others => '1');
					elem_in_05 <= (others => '1');
					elem_in_06 <= (others => '1');
					elem_in_07 <= (others => '1');
					index_s1 <= (others => '1');	
				end if;

				index_s2 <= index_s1;  -- fra elem-buffer til data..

				if (elem_in_00(7) or elem_in_01(7) or elem_in_02(7) or elem_in_03(7) or
					 elem_in_04(7) or elem_in_05(7) or elem_in_06(7) or elem_in_07(7)) = '0' then
--					report "pwm lookup active"; 

					data_00(31 downto 0) <= pwm_lookup("000", elem_in_00(6 downto 0), pwm_table);
					data_01(31 downto 0) <= pwm_lookup("001", elem_in_01(6 downto 0), pwm_table);
					data_02(31 downto 0) <= pwm_lookup("010", elem_in_02(6 downto 0), pwm_table);
					data_03(31 downto 0) <= pwm_lookup("011", elem_in_03(6 downto 0), pwm_table);
					data_04(31 downto 0) <= pwm_lookup("100", elem_in_04(6 downto 0), pwm_table);
					data_05(31 downto 0) <= pwm_lookup("101", elem_in_05(6 downto 0), pwm_table);
					data_06(31 downto 0) <= pwm_lookup("110", elem_in_06(6 downto 0), pwm_table);
					data_07(31 downto 0) <= pwm_lookup("111", elem_in_07(6 downto 0), pwm_table);
				else
--					report "pwm lookup NOT active"; 
					data_00 <= (others => '0');
					data_01 <= (others => '0');
					data_02 <= (others => '0');
					data_03 <= (others => '0');
					data_04 <= (others => '0');
					data_05 <= (others => '0');
					data_06 <= (others => '0');
					data_07 <= (others => '0');
				end if;

				index_s3 <= index_s2; -- gjennom level 1 addering...
				add_00_01 <= data_00 + data_01;
				add_02_03 <= data_02 + data_03;
				add_04_05 <= data_04 + data_05;
				add_06_07 <= data_06 + data_07;

				index_s4 <= index_s3; -- gjennom level 2 addering...
				add_00_03 <= add_00_01 + add_02_03;
				add_04_07 <= add_04_05 + add_06_07;

				index_s5 <= index_s4; -- gjennom level 3 addering...
				add_00_07 <= add_00_03 + add_04_07;

				data_out <= add_00_07;
				index_out <= index_s5;

				if index_s5(25)='0' then
--					report "pwm output valid";
					data_out_valid <= '1';
				else
--					report "pwm output NOT valid";
					data_out_valid <= '0';
				end if;
			else
--				report "pwm STALL";
				data_out_valid <= '0';
			end if;
		end if;
	end process do_stuff;

end rtl;
