
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:19:00 05/01/2007
-- Design Name:   filter
-- Module Name:   /home/dmlab/perandg/kode/fpwmv3/src/80-0037_vhdl/par/xc2vp50/filters_tb.vhd
-- Project Name:  top
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: filter
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;
USE ieee.numeric_std.ALL;

ENTITY filters_tb_vhd IS
END filters_tb_vhd;

ARCHITECTURE behavior OF filters_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT filter
	PORT(
		reset_n : IN std_logic;
		user_clk : IN std_logic;
		valid : IN std_logic;
		stall : IN std_logic;
		data_in : IN std_logic_vector(37 downto 0);
		index_in : IN std_logic_vector(25 downto 0);
		filter_comp_finished : IN std_logic;
		data_valid : OUT std_logic;
		data_out : OUT std_logic_vector(63 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset_n :  std_logic := '0';
	SIGNAL user_clk :  std_logic := '0';
	SIGNAL valid :  std_logic := '0';
	SIGNAL stall :  std_logic := '0';
	SIGNAL data_in :  std_logic_vector(37 downto 0) := (others=>'0');
	SIGNAL index_in :  std_logic_vector(25 downto 0) := (others=>'0');
	SIGNAL filter_comp_finished : std_logic := '0';
	
	--Outputs
	SIGNAL data_valid :  std_logic;
	SIGNAL data_out :  std_logic_vector(63 downto 0);

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: filter PORT MAP(
		reset_n => reset_n,
		user_clk => user_clk,
		valid => valid,
		stall => stall,
		data_in => data_in,
		index_in => index_in,
		filter_comp_finished => filter_comp_finished,
		data_valid => data_valid,
		data_out => data_out
	);

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		reset_n <= '0';
		wait for 100 ns;

		-- Place stimulus here
---------------------------------------------
--      Testbenk for summasjonsfilter      --
---------------------------------------------

		reset_n <= '1';
		wait for 10 ns;
		
		-- test filter_comp_finished og summering
		report "test filter_comp_finished og summering (1/6)";
		data_in <= (others => '0');
		valid <= '1';
		while data_in < 100 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			wait for 1 ns;
		end loop;
		
		filter_comp_finished <= '1';
		valid <= '0';
		wait for 4 ns;
		filter_comp_finished <= '0';
		wait for 10 ns;
		
		-- test filter_comp_finished med input mens filter_comp_finished er høy
		report "test filter_comp_finished med input mens filter_comp_finished er høy (2/6)";
		data_in <= (others => '0');
		valid <= '1';
		while data_in < 104 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			if data_in>100 then
				filter_comp_finished <= '1';
			else
				filter_comp_finished <= '0';
			end if;
			wait for 1 ns;
		end loop;
		
		valid <= '0';
		wait for 4 ns;
		filter_comp_finished <= '0';
		wait for 10 ns;		
		
		-- test utskrift etter 1000 summeringer
		report "test utskrift etter 1000 summeringer (3/6)";
		data_in <= (others => '0');
		valid <= '1';
		while data_in < 1100 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			wait for 1 ns;
		end loop;
		
		filter_comp_finished <= '1';
		valid <= '0';
		wait for 4 ns;
		filter_comp_finished <= '0';
		wait for 10 ns;

		-- test reset
		report "test reset (4/6)";
		data_in <= (others => '0');
		valid <= '1';
		wait for 2 ns;
		while data_in < 100 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			wait for 1 ns;
		end loop;
		
		reset_n <= '0';
		valid <= '0';
		wait for 2 ns;
		reset_n <= '1';
		wait for 10 ns;
		
		data_in <= (others => '0');
		valid <= '1';
		wait for 2 ns;
		while data_in < 100 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			wait for 1 ns;
		end loop;

		filter_comp_finished <= '1';
		valid <= '0';
		wait for 4 ns;
		filter_comp_finished <= '0';
		wait for 10 ns;

		-- test stall
		report "test stall (5/6)";
		stall <= '1';
		data_in <= (others => '0');
		valid <= '1';
		wait for 2 ns;
		while data_in < 100 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			wait for 1 ns;
		end loop;

		filter_comp_finished <= '1';
		valid <= '0';
		wait for 4 ns;
		filter_comp_finished <= '0';
		wait for 10 ns;

		-- test stall og filter_comp_finished med input mens filter_comp_finished er høy
		report "test stall og filter_comp_finished med input mens filter_comp_finished er høy (6/6)";
		data_in <= (others => '0');
		valid <= '1';
		wait for 2 ns;
		while data_in < 104 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			if data_in>100 then
				filter_comp_finished <= '1';
			else
				filter_comp_finished <= '0';
			end if;
			wait for 1 ns;
		end loop;
		
		valid <= '0';
		wait for 4 ns;
		filter_comp_finished <= '0';
		wait for 10 ns;

		wait; -- will wait forever
	END PROCESS;

	clock : PROCESS
	variable counter : integer;
	BEGIN
		wait for 100 ns;
		--reset_n <= '1';
		user_clk <= '1';
		while counter < 100 loop
			wait for 1 ns;
			user_clk <= '0';
			wait for 1 ns;
			user_clk <= '1';
			counter := counter + 1;
		end loop;
		report "Finished clock-process";
	END PROCESS;

END;
