
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   13:07:45 05/10/2007
-- Design Name:   filter
-- Module Name:   /home/dmlab/perandg/kode/fpwmv3/src/80-0037_vhdl/par/xc2vp50/filtert_tb.vhd
-- Project Name:  top
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: filter
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY filtert_tb_vhd IS
END filtert_tb_vhd;

ARCHITECTURE behavior OF filtert_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT filter
	PORT(
		reset_n : IN std_logic;
		user_clk : IN std_logic;
		valid : IN std_logic;
		stall : IN std_logic;
		data_in : IN std_logic_vector(37 downto 0);
		index_in : IN std_logic_vector(25 downto 0);
		threshold : IN std_logic_vector(37 downto 0);          
		data_valid : OUT std_logic;
		data_out : OUT std_logic_vector(63 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset_n :  std_logic := '0';
	SIGNAL user_clk :  std_logic := '0';
	SIGNAL valid :  std_logic := '0';
	SIGNAL stall :  std_logic := '0';
	SIGNAL data_in :  std_logic_vector(37 downto 0) := (others=>'0');
	SIGNAL index_in :  std_logic_vector(25 downto 0) := (others=>'0');
	SIGNAL threshold :  std_logic_vector(37 downto 0) := (others=>'0');

	--Outputs
	SIGNAL data_valid :  std_logic;
	SIGNAL data_out :  std_logic_vector(63 downto 0);

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: filter PORT MAP(
		reset_n => reset_n,
		user_clk => user_clk,
		valid => valid,
		stall => stall,
		data_in => data_in,
		index_in => index_in,
		threshold => threshold,
		data_valid => data_valid,
		data_out => data_out
	);

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		reset_n <= '0';
		wait for 100 ns;
		
		-- Place stimulus here

---------------------------------------------
--        Testbenk for terskelfilter       --
---------------------------------------------

		reset_n <= '1';
		-- test at thresh-verdien setter seg
		report "test at thresh-verdien setter seg (1/5)";
		threshold <= B"00000000000000000000000000000000000100";
		wait for 10 ns;
		
		-- test at terskelverdien velger riktig
		report "test at terskelverdien velger riktig (2/5)";
		valid <= '1';
		data_in <= B"00000000000000000000000000000000000000";
		while data_in < 18 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			wait for 1 ns;
		end loop;

		-- test at data_valid blir satt riktig avhengig av valid og terskel
		report "test at data_valid blir satt riktig avhengig av valid og terskel (3/5)";
		wait for 5 ns;
		valid <= '0';
		data_in <= B"00000000000000000000000000000000000000";
		wait for 5 ns;
		while data_in < 18 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			valid <= not valid;
			wait for 1 ns;
		end loop;
	
		wait for 10 ns;
		
		-- test reset_n med oppretting av verdier etterpå, og test at data_valid blir satt riktig avhengig av terskel og valid
		report "test reset_n med oppretting av verdier etterpå, og test at data_valid blir satt riktig avhengig av terskel og valid (4/5)";
		reset_n <= '0';
		threshold <= (others => '0'); -- Nullstill verdier som ville blitt nullstilt i andre moduler ved reset_n=0
		data_in <= (others => '0');
		index_in <= (others => '0');
		valid <= '0';
		stall <= '0';
		wait for 10 ns;
		reset_n <= '1';
		wait for 2 ns;
		threshold <= B"00000000000000000000000000000000001000";

		wait for 10 ns;
		
		valid <= '1';
		data_in <= B"00000000000000000000000000000000000000";
		while data_in < 18 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			wait for 1 ns;
		end loop;

		wait for 5 ns;
		valid <= '0';
		data_in <= B"00000000000000000000000000000000000000";
		wait for 5 ns;
		while data_in < 18 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			valid <= not valid;
			wait for 1 ns;
		end loop;

		-- test at stall stopper testing av data og setter data_valid inaktivt
		report "test at stall stopper testing av data og setter data_valid inaktivt (5/5)";
		wait for 10 ns;
		stall <= '1';
		valid <= '0';
		data_in <= B"00000000000000000000000000000000000000";
		wait for 5 ns;
		while data_in < 18 loop
			wait for 1 ns;
			data_in <= data_in + 1;
			valid <= not valid;
			wait for 1 ns;
		end loop;

		wait; -- will wait forever
	END PROCESS;

	receiver : PROCESS (data_out, stall)
	begin
		if stall = '1' then
			if data_out&data_valid /= 0 then
				report "stall = 1, data_out&data_valid /= 0";
			end if;
		else
			if data_out > threshold then
				if valid /= data_valid then
					report "data_valid /= valid, data_out > threshold";
				end if;
			else
				if data_valid = '1' then
					report "data_valid = 1, data_out <= threshold";
				end if;
			end if;
		end if;
	end process receiver;

	clock : PROCESS
	variable counter : integer;
	BEGIN
		wait for 100 ns;
		--reset_n <= '1';
		user_clk <= '1';
		while counter < 100 loop
			wait for 1 ns;
			user_clk <= '0';
			wait for 1 ns;
			user_clk <= '1';
			counter := counter + 1;
		end loop;
		report "Finished clock-process";
	END PROCESS;

END;
