
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   10:32:26 05/02/2007
-- Design Name:   writer
-- Module Name:   /home/dmlab/perandg/kode/fpwmv3/src/80-0037_vhdl/par/xc2vp50/writer2_tb.vhd
-- Project Name:  top
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: writer
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY writer2_tb_vhd IS
END writer2_tb_vhd;

ARCHITECTURE behavior OF writer2_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT writer
	PORT(
		reset_n : IN std_logic;
		user_clk : IN std_logic;
		valid : IN std_logic;
		bypass : IN std_logic;
		flush : IN std_logic;
		set_base_addr : IN std_logic;
		data_in : IN std_logic_vector(63 downto 0);
		addr_in : IN std_logic_vector(39 downto 3);
		ureq_srctag : IN std_logic_vector(4 downto 0);
		ureq_full : IN std_logic;
		ureq_notag : IN std_logic;          
		stall : OUT std_logic;
		empty : OUT std_logic;
		overflow : OUT std_logic;
		ureq_addr : OUT std_logic_vector(39 downto 3);
		ureq_size : OUT std_logic_vector(2 downto 0);
		ureq_mask : OUT std_logic_vector(7 downto 0);
		ureq_rw_n : OUT std_logic;
		ureq_data : OUT std_logic_vector(63 downto 0);
		ureq_ts : OUT std_logic;
		ureq_byte_req : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset_n :  std_logic := '0';
	SIGNAL user_clk :  std_logic := '0';
	SIGNAL valid :  std_logic := '0';
	SIGNAL bypass :  std_logic := '0';
	SIGNAL flush :  std_logic := '0';
	SIGNAL set_base_addr :  std_logic := '0';
	SIGNAL ureq_full :  std_logic := '0';
	SIGNAL ureq_notag :  std_logic := '0';
	SIGNAL data_in :  std_logic_vector(63 downto 0) := (others=>'0');
	SIGNAL addr_in :  std_logic_vector(39 downto 3) := (others=>'0');
	SIGNAL ureq_srctag :  std_logic_vector(4 downto 0) := (others=>'0');

	--Outputs
	SIGNAL stall :  std_logic;
	SIGNAL empty :  std_logic;
	SIGNAL overflow :  std_logic;
	SIGNAL ureq_addr :  std_logic_vector(39 downto 3);
	SIGNAL ureq_size :  std_logic_vector(2 downto 0);
	SIGNAL ureq_mask :  std_logic_vector(7 downto 0);
	SIGNAL ureq_rw_n :  std_logic;
	SIGNAL ureq_data :  std_logic_vector(63 downto 0);
	SIGNAL ureq_ts :  std_logic;
	SIGNAL ureq_byte_req :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: writer PORT MAP(
		reset_n => reset_n,
		user_clk => user_clk,
		valid => valid,
		bypass => bypass,
		flush => flush,
		set_base_addr => set_base_addr,
		data_in => data_in,
		addr_in => addr_in,
		stall => stall,
		empty => empty,
		overflow => overflow,
		ureq_srctag => ureq_srctag,
		ureq_full => ureq_full,
		ureq_notag => ureq_notag,
		ureq_addr => ureq_addr,
		ureq_size => ureq_size,
		ureq_mask => ureq_mask,
		ureq_rw_n => ureq_rw_n,
		ureq_data => ureq_data,
		ureq_ts => ureq_ts,
		ureq_byte_req => ureq_byte_req
	);

	tb : PROCESS
	variable data : std_logic_vector(63 downto 0);
	BEGIN

		-- Wait 100 ns for global reset to finish
		reset_n <= '0';
		wait for 100 ns;
		reset_n <= '1';
		
		-- Place stimulus here

		set_base_addr <= '1';
		addr_in <= B"0000000000000000000000000000000000001";
		wait for 1 ns; 
		set_base_addr <= '0';
		wait for 1 ns;
		
		valid <= '1';
		data := X"0000000000000000";
		while data < 8 loop
			data := data + 1;
			wait for 1 ns;
			data_in <= data;
			wait for 1 ns;
		end loop;
		valid <= '0';

		wait; -- will wait forever
	END PROCESS;
	clock : PROCESS
	variable counter : integer;
	BEGIN
		wait for 100 ns;
--		reset_n <= '1';
		user_clk <= '1';
		while counter < 100 loop
			wait for 1 ns;
			user_clk <= '0';
			wait for 1 ns;
			user_clk <= '1';
			counter := counter + 1;
		end loop;
		report "Finished clock-process";
	END PROCESS;

END;
