
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   21:01:31 04/06/2007
-- Design Name:   writer
-- Module Name:   /home/dmlab/perandg/kode/fpwmv3/src/80-0037_vhdl/par/xc2vp50/writer_tbw.vhd
-- Project Name:  top
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: writer
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY writer_tbw_vhd IS
END writer_tbw_vhd;

ARCHITECTURE behavior OF writer_tbw_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT writer
	PORT(
		reset_n : IN std_logic;
		user_clk : IN std_logic;
		valid : IN std_logic;
		bypass : IN std_logic;
		flush : IN std_logic;
		set_base_addr : IN std_logic;
		data_in : IN std_logic_vector(63 downto 0);
		addr_in : IN std_logic_vector(39 downto 3);
		ureq_srctag : IN std_logic_vector(4 downto 0);
		ureq_full : IN std_logic;
		ureq_notag : IN std_logic;          
		stall : OUT std_logic;
		empty : OUT std_logic;
		overflow : OUT std_logic;
		ureq_addr : OUT std_logic_vector(39 downto 3);
		ureq_size : OUT std_logic_vector(2 downto 0);
		ureq_mask : OUT std_logic_vector(7 downto 0);
		ureq_rw_n : OUT std_logic;
		ureq_data : OUT std_logic_vector(63 downto 0);
		ureq_ts : OUT std_logic;
		ureq_byte_req : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset_n :  std_logic := '0';
	SIGNAL user_clk :  std_logic := '0';
	SIGNAL valid :  std_logic := '0';
	SIGNAL bypass :  std_logic := '0';
	SIGNAL flush :  std_logic := '0';
	SIGNAL set_base_addr :  std_logic := '0';
	SIGNAL ureq_full :  std_logic := '0';
	SIGNAL ureq_notag :  std_logic := '0';
	SIGNAL data_in :  std_logic_vector(63 downto 0) := (others=>'0');
	SIGNAL addr_in :  std_logic_vector(39 downto 3) := (others=>'0');
	SIGNAL ureq_srctag :  std_logic_vector(4 downto 0) := (others=>'0');

	--Outputs
	SIGNAL stall :  std_logic;
	SIGNAL empty :  std_logic;
	SIGNAL overflow :  std_logic;
	SIGNAL ureq_addr :  std_logic_vector(39 downto 3);
	SIGNAL ureq_size :  std_logic_vector(2 downto 0);
	SIGNAL ureq_mask :  std_logic_vector(7 downto 0);
	SIGNAL ureq_rw_n :  std_logic;
	SIGNAL ureq_data :  std_logic_vector(63 downto 0);
	SIGNAL ureq_ts :  std_logic;
	SIGNAL ureq_byte_req :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: writer PORT MAP(
		reset_n => reset_n,
		user_clk => user_clk,
		valid => valid,
		bypass => bypass,
		flush => flush,
		set_base_addr => set_base_addr,
		data_in => data_in,
		addr_in => addr_in,
		stall => stall,
		empty => empty,
		overflow => overflow,
		ureq_srctag => ureq_srctag,
		ureq_full => ureq_full,
		ureq_notag => ureq_notag,
		ureq_addr => ureq_addr,
		ureq_size => ureq_size,
		ureq_mask => ureq_mask,
		ureq_rw_n => ureq_rw_n,
		ureq_data => ureq_data,
		ureq_ts => ureq_ts,
		ureq_byte_req => ureq_byte_req
	);

	tb : PROCESS
	variable data : std_logic_vector(63 downto 0);
	variable counter : std_logic_vector(7 downto 0);
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- Place stimulus here
		reset_n <= '1';
		set_base_addr <= '1';
		addr_in <= B"0000000000000000000000000000000000001";
		wait for 1 ns;
		set_base_addr <= '0';
		wait for 1 ns;
		wait for 10 ns;
		valid <= '1';
		-- test flush, skriv 6 elementer og flush
		report "test flush, skriv 6 elementer og flush";
		data := X"0000000000000000";
		while data < 6 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		wait for 4 ns;
		flush <= '1';
		wait for 20 ns;
		flush <= '0';
		wait for 2 ns;
		-- test flush, skriv 60 elementer og flush
		report "test flush, skriv 60 elementer og flush";
		data := X"0000000000000000";
		valid <= '1';
		while data < 60 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		wait for 2 ns;
		flush <= '1';
		wait for 30 ns;
		flush <= '0';
		wait for 2 ns;
		-- Test overføring av 9 elementer, slik at en blir liggende igjen.
		report "Test overføring av 9 elementer, slik at en blir liggende igjen.";
		valid <= '1';
		data := X"0000000000000000";
		while data < 9 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		
		-- test overføring av 15 elementer slik at brams blir tømt
		report "test overføring av 15 elementer slik at brams blir tømt";
		wait for 20 ns;
		data := X"0000000000000000";
		valid <= '1';
		while data < 15 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		wait for 30 ns;

		-- Test overføring av 24 elementer
		report "Test overføring av 24 elementer";
		data := X"0000000000000000";
		valid <= '1';
		while data < 24 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		wait for 40 ns;

		-- test overføring etter reset, med set_base_adress
		report "test overføring etter reset, med set_base_adress";
		reset_n <= '0';
		wait for 2 ns;
		reset_n <= '1';
		wait for 2 ns;
		set_base_addr <= '1';
		addr_in <= B"0000000000000000000000000000000000010";
		wait for 1 ns;
		set_base_addr <= '0';
		wait for 1 ns;
		-- Test overføring av 24 elementer
		data := X"0000000000000000";
		valid <= '1';
		while data < 24 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		wait for 40 ns;

		-- Test overføring av 64 elementer
		report "Test overføring av 64 elementer";
		data := X"0000000000000000";
		valid <= '1';
		while data < 64 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		wait for 100 ns;

		-- Test overføring av 64 elementer og flush
		report "Test overføring av 64 elementer og flush";
		data := X"0000000000000000";
		valid <= '1';
		while data < 64 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';
		wait for 10 ns;
		flush <= '1';
		wait for 10 ns;
		flush <= '0';
		wait for 20 ns;

		-- sjekk flush med 1, 2, ... , 7 elementer
		report "sjekk flush med 1, 2, ... , 7 elementer";
		counter := B"00000000";
		while counter < 8 loop
			data := X"0000000000000000";
			valid <= '1';
			while data <= counter loop
				data := data + 1;
				--valid <= '1';
				data_in <= data;
				wait for 1 ns;
				--valid <= '0';
				wait for 1 ns;
			end loop;
			valid <= '0';
			wait for 10 ns;
			flush <= '1';
			wait for 10 ns;
			flush <= '0';
			wait for 20 ns;
			
			counter := counter + 1;
		end loop;

		-- Test for å sjekke om minnet er syklisk
		report "Test for å sjekke om minnet er syklisk";
		data := X"0000000000000000";
		valid <= '1';
		while data < 270 loop
			data := data + 1;
			--valid <= '1';
			data_in <= data;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';		
		wait for 2 ns;
		flush <= '1';
		wait for 2 ns;
		flush <= '0';
		wait for 10 ns;
		
		-- Prøv med gyldig skriving og aktiv flush
		report "Prøv med gyldig skriving og aktiv flush";
		data := X"0000000000000000";
		valid <= '1';
		while data < 270 loop
			data := data + 1;
			data_in <= data;
			if data = 130 then
				flush <= '1';
			end if;
			wait for 2 ns;
		end loop;
		valid <= '0';		
		wait for 20 ns;
		flush <= '0';
		wait for 20 ns;
		
		
		-- test etter overflow/full
		report "test etter overflow/full";
		data := X"0000000000000000";
		valid <= '1';
		while overflow = '0' loop
			data := data + 1;
			--valid <= '1';
			if stall = '0' then
				data_in <= data;
				valid <= '1';
			else
				valid <= '0';
			end if;
			wait for 1 ns;
			--valid <= '0';
			wait for 1 ns;
		end loop;
		valid <= '0';		
				
		
		
		wait; -- will wait forever
	END PROCESS;
	
	clock : PROCESS
	variable counter : integer;
	BEGIN
		wait for 100 ns;
--		reset_n <= '1';
		user_clk <= '1';
		while counter < 100 loop
			wait for 1 ns;
			user_clk <= '0';
			wait for 1 ns;
			user_clk <= '1';
			counter := counter + 1;
		end loop;
		report "Finished clock-process";
	END PROCESS;
END;
